﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CardPlay
{
    class Card
    {
        private string Face { get; }
        private string Suit { get; }

        public Card(string face, string suit)
        {
            Face = face;
            Suit = suit;
        }
        
        public override string ToString() => $"{Face} of {Suit}";
        
            
        
        
    }
    class DeckOfCards
    {
        private static Random randomNumber = new Random();

        private const int NumberOfCards = 52;
        private Card[] deck = new Card[NumberOfCards];
        private int currentCard = 0;
        public DeckOfCards()
        {
            string[] faces = { "Ace", "Deuce", "Three", "Four", "Five", "Six", "Seven", "Eight", "Nine", "Ten", "Jack", "Queen", "King" };
            string[] suits = { "Hearts", "Diamonds", "Clubs", "Spades" };

            for (var count= 0; count< deck.Length; ++count)
            {
                deck[count] = new Card(faces[count % 13], suits[count / 13]);
            }
        }
        public void Shuffle()
        {
            currentCard = 0;

            for(var first = 0; first< deck.Length; ++first)
            {
                var second = randomNumber.Next(NumberOfCards);

                Card temp = deck[first];
                deck[first] = deck[second];
                deck[second] = temp;
            }
        }
        public Card DealCard()
        {
            if (currentCard < deck.Length)
            {
                return deck[currentCard++];
            }
            else
            {
                return null;
            }

        }
    }
    class DeckOfCardstest
    {
        static void Main()
        {
            var myDeckOfcards = new DeckOfCards();
            myDeckOfcards.Shuffle();

            for(var i = 0; i< 52; ++i)
            {
                Console.Write($"{myDeckOfcards.DealCard(),-19}");

                if((i+1)% 4 == 0)
                {
                    Console.WriteLine();
                }
            }
            Console.ReadKey();
        }
    }

}
